
/*===============================================*\
	Vendredi 11 Septembre 1998

	Arash HABIBI

	SocketToolbox.h

 	Un ensemble de fonctions qu'on utilise
	partout en manipulant les sockets.  
	
\*================================================*/


#ifndef _SOCKETTOOLBOX_H_
#define _SOCKETTOOLBOX_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>
#include <fcntl.h>

/* Une structure pour reprsenter les adresse IP sous */
/* leur forme habituelle : n1.n2.n3.n4                */

typedef struct AdresseIP_t
{
  unsigned int n1, n2, n3, n4;
} AdresseIP_t; 


/* Etant donne le nom d'une machine et son numro de port, cette fonction          */
/* retourne l'adresse de type struct sockaddr_in correspondant (format rseau)      */
extern struct sockaddr_in ST_WriteNetworkAddress(char *nommachine, u_short port);

/* Etant donne une structure de type struct sockaddr_in, au format rseau,         */
/* cette fonction retourne l'adresse IP sous forme n1.n2.n3.n4 (struct AdresseIP_t) */
/* et le numro de port correspondant. */
extern void ST_ReadNetworkAddress(struct sockaddr_in adresse, AdresseIP_t *AIP, u_short *port);

/* Ouvre une socket type, l'attache sur le port numro port (ventuellement 0),     */
/* et retourne l'adresse de la socket locale, de faon  ce qu'on puisse            */
/* ventuellement lire le numro de port que la machine a finalement choisie.       */
extern int ST_GetAndBindSocket(int type, short port, struct sockaddr_in *adresse);

/* Retourne 1 si les deux adresses sont identiques et 0 sinon.                      */
extern int ST_SameAddress(struct sockaddr_in adr_1, struct sockaddr_in adr_2);

/* Affiche  l'cran l'adresse IP et numro de port correspondant  adresse         */
extern void ST_CheckNetworkAddress(struct sockaddr_in adr_1, char *comment); 

#endif
