
/*===============================================*\
  
  Mercredi 13 Decembre 2000  

  Arash HABIBI
  
  main.c
  
  Le module principal. 
  Ce medium prend en argument deux adresses distantes
  un taux d'erreur et un taux de perte. 
  Son travail consiste a attendre derriere ses 
  sockets. Quand il recoit un message d'une des 
  deux adresses, il le renvoie a l'autre et vice-versa. 
  Mais quelquefois il pourra perdre une trame ou 
  y introduire une erreur. 
  
\*================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "Medium.h"
#include "SocketToolbox.h"

/*------------------------------------------------*\
\*------------------------------------------------*/

void _TraitementParametres(int argc, char **argv, char *nom_machine1, short *port_machine1, char *nom_machine2, short *port_machine2, float *taux_perte, float *taux_erreur)
{
  if(argc<7)
    {
      fprintf(stderr,"\nUsage : %s nom1 port1 nom2 port2 taux_perte taux_erreur\n\n", 
	      argv[0]);
      exit(1);
    }
  else
    {
      strcpy(nom_machine1, argv[1]);
      *port_machine1 = atoi(argv[2]);
      strcpy(nom_machine2, argv[3]);
      *port_machine2 = atoi(argv[4]);
      *taux_perte  = atof(argv[5]);
      *taux_erreur = atof(argv[6]);

      if((*taux_perte <0)||(*taux_perte>1)||
	 (*taux_erreur<0)||(*taux_erreur>1))
	{
	  fprintf(stderr,"\ntaux_erreur(%f) et taux_perte(%f) doivent \n", 
		  *taux_erreur, *taux_perte);
	  fprintf(stderr,"appartenir tous deux a l'intervalle [0;1].\n");
	  exit(1);
	}
    }  
}


/*------------------------------------------------*\
\*------------------------------------------------*/

int main(int argc, char **argv)
{
  short port_machine1, port_machine2; 
  char nom_machine1[50], nom_machine2[50];
  float taux_erreur, taux_perte; 
  struct sockaddr_in adr_1, adr_2; 

  _TraitementParametres(argc, argv, 
			nom_machine1, &port_machine1, 
			nom_machine2, &port_machine2, 
			&taux_perte, &taux_erreur);

  adr_1 = ST_WriteNetworkAddress(nom_machine1, port_machine1);
  adr_2 = ST_WriteNetworkAddress(nom_machine2, port_machine2);

  if(M_ExecMedium(adr_1, adr_2, taux_perte, taux_erreur)==M_ERREUR)
    printf("\nTransmission interrompue .\n\n");

  else //if(diagnostique==M_TERMINE)
    printf("\nTransmission termine .\n\n");

  return 0;
}
